#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green

extern int WorkPeriod             =PERIOD_MN1;

extern int StochasticKperiod1=5;//5
extern int StochasticDperiod1=3;//3
extern int StochasticSlowing1=3;//6

double ExtMapBuffer0[];
double ExtMapBuffer1[];


double value1,value2;

int nBar;      
bool Buy;

int ExtCountedBars;

int init(){
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,2);
                        
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexBuffer(1,ExtMapBuffer1);
   IndicatorShortName("STOCHASTIC("+StochasticKperiod1+","+StochasticDperiod1+","+StochasticSlowing1+")"+WorkPeriod);

   return(0);
}
int start()
  {
   if(Bars<=40) return(0);
   ExtCountedBars=IndicatorCounted();
   if (ExtCountedBars<0) return(-1);
   if (ExtCountedBars>0) ExtCountedBars--;
   int CurrentBar=Bars-ExtCountedBars-1;
   
   while(CurrentBar>=0)
     {
      value1=0;
      value2=0;

      nBar=iBarShift(NULL,WorkPeriod,Time[CurrentBar],false) ;      
      Buy=(iStochastic(NULL,WorkPeriod,StochasticKperiod1,StochasticDperiod1,StochasticSlowing1,MODE_SMA,0,MODE_MAIN,nBar)>
           iStochastic(NULL,WorkPeriod,StochasticKperiod1,StochasticDperiod1,StochasticSlowing1,MODE_SMA,0,MODE_SIGNAL,nBar)); 
      
      if (Buy){            
          value1=0;
          value2=1;
          }
      if (!Buy){            
          value1=1;
          value2=0;
      }

      ExtMapBuffer0[CurrentBar]=value1;
      ExtMapBuffer1[CurrentBar]=value2;
      
 	   CurrentBar--;
     }
 return(0);
 }

